#include <windows.h>
#include <winnt.h>
#include <stdio.h>

//int PASCAL WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
//					LPSTR lpszCmd, int nCmdShow)
int main(int argc,char *argv[])
{
  HANDLE hTape;   /* handle to tape device */ 
  DWORD res;
  char tape[30];
  int x;
 
  if (argc!=2)
  {
    printf("Retention V0.2  (c) 11-07-1997 by Jorgen Bosman\n");
    printf("Usage: retention <tape number>\n");
    printf("The tape number is usually 0\n");
    exit(-1);
  }
  sprintf(tape,"\\\\.\\TAPE%s",argv[1]);
  hTape = CreateFile( 
//    "\\\\.\\TAPE1",     /* name of tape device to open */ 
    tape,
    GENERIC_READ | GENERIC_WRITE, /* read-write access */ 
    0,                    /* not used                  */ 
    0,                    /* not used                  */ 
    OPEN_EXISTING,        /* required for tape devices */ 
    0,                    /* not used                  */ 
    NULL);                /* not used                  */ 
 
  if (hTape==INVALID_HANDLE_VALUE)
  {
    printf("\nCan't open tape device %s\n",tape);
    return -1;
  }
 
  res=PrepareTape(hTape,TAPE_LOAD,FALSE);
  x=0;
  do
  {
    if (x%4==0)
    {
        CloseHandle(hTape);
    hTape = CreateFile( 
  //    "\\\\.\\TAPE1",     /* name of tape device to open */ 
      tape,
      GENERIC_READ | GENERIC_WRITE, /* read-write access */ 
      0,                    /* not used                  */ 
      0,                    /* not used                  */ 
      OPEN_EXISTING,        /* required for tape devices */ 
      0,                    /* not used                  */ 
      NULL);                /* not used                  */ 
    }
    res=PrepareTape(hTape,TAPE_TENSION,FALSE);
  } while (res!=NO_ERROR && x++<10);
  if (res!=NO_ERROR)
  {
    printf("Can't retension tape, error_code=%d\n",(int)res);
    switch (res)
    {
      case ERROR_BEGINNING_OF_MEDIA:printf("An attempt to access data before the beginning-of-medium marker failed. \n");break;
      case ERROR_BUS_RESET:printf("A reset condition was detected on the bus. \n");break;
      case ERROR_END_OF_MEDIA:printf("The end-of-tape marker was reached during an operation. \n");break;
      case ERROR_FILEMARK_DETECTED:printf("A filemark was reached during an operation. \n");break;
      case ERROR_SETMARK_DETECTED:printf("A setmark was reached during an operation. \n");break;
      case ERROR_NO_DATA_DETECTED:printf("The end-of-data marker was reached during an operation. \n");break;
      case ERROR_PARTITION_FAILURE:printf("The tape could not be partitioned. \n");break;
      case ERROR_INVALID_BLOCK_LENGTH:printf("The block size is incorrect on a new tape in a multivolume partition. \n");break;
      case ERROR_DEVICE_NOT_PARTITIONED:printf("The partition information could not be found when a tape was being loaded. \n");break;
      case ERROR_MEDIA_CHANGED:printf("The tape that was in the drive has been replaced or removed. \n");break;
      case ERROR_NO_MEDIA_IN_DRIVE:printf("There is no media in the drive. \n");break;
      case ERROR_NOT_SUPPORTED:printf("The tape driver does not support a requested function. \n");break;
      case ERROR_UNABLE_TO_LOCK_MEDIA:printf("An attempt to lock the ejection mechanism failed. \n");break;
      case ERROR_UNABLE_TO_UNLOAD_MEDIA:printf("An attempt to unload the tape failed. \n");break;
      case ERROR_WRITE_PROTECT:printf("The media is write protected.\n");break;
      default:printf("Unknown error\n");break;
    }
    CloseHandle(hTape);
    return -1;
  }
  CloseHandle(hTape);
  return 0;
}